----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 	Dimitrios Porlidas
-- 
-- Create Date:    00:10:00 01/18/2016 
-- Design Name:    AddMulCoun
-- Module Name:    counter - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity counter is
port (
			CLK: in STD_LOGIC;
			BTNW: in STD_LOGIC;
			BTNE: in STD_LOGIC;
			BTNU: in STD_LOGIC;
			BTND: in STD_LOGIC;
			count: buffer STD_LOGIC_VECTOR (7 downto 0)
		);
end counter;

architecture Behavioral of counter is

	signal state: STD_LOGIC_VECTOR (27 downto 0);
	signal UPDN: STD_LOGIC;
	signal ONOFF: STD_LOGIC;

begin

	count <= state (27 downto 20);

process (CLK)

begin

	if CLK='1' and CLK'event then
		if ONOFF='1' then
			if UPDN='0' then
				state<=state+1;
				elsif UPDN='1' then
				state<=state-1;
			end if;
			elsif ONOFF='0' then
			state<= X"0000000";
		end if;	
	end if;	
			
	if CLK='0' and CLK'event then
		if BTNU='1' then UPDN<='0';
			elsif BTND='1' then UPDN<='1';
		end if;
		if BTNW='1' then ONOFF<='0';
			elsif BTNE='1' then ONOFF<='1';
		end if;
	end if;
	
end process;

end Behavioral;

