----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 	Dimitrios Porlidas
-- 
-- Create Date:    03:00:30 01/18/2016 
-- Design Name:    AddMulCoun
-- Module Name:    multip - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity multip is
port (
			CLK: in STD_LOGIC;
			SW0: in STD_LOGIC;
			SW1: in STD_LOGIC;
			SW2: in STD_LOGIC;
			SW3: in STD_LOGIC;
			BTNW: in STD_LOGIC;
			BTNE: in STD_LOGIC;
			prod: buffer STD_LOGIC_VECTOR (3 downto 0)
		);
end multip;

architecture Behavioral of multip is

	signal num1: STD_LOGIC_VECTOR (1 downto 0);
	signal num2: STD_LOGIC_VECTOR (1 downto 0);

begin

--	num2 (2) <= '0';
	num2 (1) <= SW3;
	num2 (0) <= SW2;
--	num1 (2) <= '0';
	num1 (1) <= SW1;
	num1 (0) <= SW0;

process

begin

	if BTNE='1' then prod <= num1 * num2;
	elsif BTNW='1' then prod <= "0000";
	end if;
	
end process;

end Behavioral;



